unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Windows, Messages , Dialogs ;

type
  TCommFortProcess = procedure(dwPluginID : DWORD; dwID: DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD); stdcall;
  TCommFortGetData = function(dwPluginID : DWORD; dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; stdcall;

function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; stdcall; export;
procedure PluginStop(); export;
procedure PluginShowOptions(); export;
procedure PluginShowAbout(); export;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);  stdcall;  export;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
             dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;  stdcall;  export;
function  PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD):  Integer;  stdcall;  export;


function  fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer;
function  fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString;
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer);
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString);
function  fTextToAnsiString(uText : WideString) : AnsiString;
function  fIntegerToAnsiString(iValue : Integer) : AnsiString;

var
  dwPluginID : DWORD;
  CommFortProcess : TCommFortProcess;
  CommFortGetData : TCommFortGetData;

implementation

//---------------------------------------------------------------------------
function fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer; //       
begin
	CopyMemory(@Result, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
end;

function fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString; //       
 var iLength : Integer;
begin
	CopyMemory(@iLength, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
	SetLength(Result, iLength);
	CopyMemory(@Result[1], bInBuffer + iOffSet, iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer); //       
begin
	CopyMemory(bOutBuffer + iOffSet, @iValue, 4);
	iOffset := iOffset + 4;
end;
//---------------------------------------------------------------------------
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString); //       
	var iLength : Integer;
begin
	iLength := Length(uValue);
	CopyMemory(bOutBuffer + iOffset, @iLength, 4);
	iOffset := iOffset + 4;

	CopyMemory(bOutBuffer + iOffSet, @uValue[1], iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
function fTextToAnsiString(uText : WideString) : AnsiString; //      
	var iLength : Integer;
begin
	//    ,
	//    ,
	//        
	iLength := Length(uText);

	SetLength(Result, 4 + iLength * 2);

	CopyMemory(@Result[1], @iLength, 4);
	CopyMemory(PAnsiChar(Result) + 4, @uText[1], iLength * 2);
end;
//---------------------------------------------------------------------------
function fIntegerToAnsiString(iValue : Integer) : AnsiString; //      
begin
	//    ,
	//    ,
	//        

	SetLength(Result, 4);
	CopyMemory(@Result[1], @iValue, 4);
end;
//---------------------------------------------------------------------------

function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;  stdcall;
var
   iSize, iReadOffset  : integer ;
   aData : WideString ;
begin
	dwPluginID := dwThisPluginID;
	//     
	//   ,  
	//      
	CommFortProcess := func1;
        //   ,
	//      

	CommFortGetData := func2;
        //   ,
        //         

// :
//TRUE -   
//FALSE -  
  Result := Integer(TRUE);

  iSize := CommFortGetData(dwPluginID, 2010, nil, 0, nil, 0); //  
  SetLength(aData, iSize);
  CommFortGetData(dwPluginID, 2010, PAnsiChar(aData), iSize, nil, 0);// 

  iReadOffset := 0;
  //  - 

  ShowMessage('Options path =' + fReadText(PAnsiChar(aData), iReadOffset) );

end;

//---------------------------------------------------------------------------
procedure PluginStop();
begin
  //      
  ShowMessage('PluginStop');

end;

//---------------------------------------------------------------------------
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);  stdcall;
var iReadOffset, iSenderIcon, iMessageMode : Integer;
    aDataToSend : AnsiString;
    uSenderLogin, uSenderIP, uChannel, uText : WideString;
begin
	//  
	//:
	//dwID -  
	//bInBuffer -   
	//dwInBufferSize -    
 iReadOffset:= 0 ;
 if (dwID = 5) then //   
 begin
  //   
  uSenderLogin := fReadText(bInBuffer, iReadOffset);// 
  uSenderIP := fReadText(bInBuffer, iReadOffset);//IP- 
  iSenderIcon := fReadInteger(bInBuffer, iReadOffset);// 
  uChannel := fReadText(bInBuffer, iReadOffset);//,     
  iMessageMode := fReadInteger(bInBuffer, iReadOffset);// 
  uText := fReadText(bInBuffer, iReadOffset);// 

  //  
  aDataToSend := fTextToAnsiString(uSenderLogin)+  // 
                 fIntegerToAnsiString(iMessageMode)+  // 
	  	 fTextToAnsiString(uText); //
  CommFortProcess(dwPluginID, 70, PAnsiChar(aDataToSend), Length(aDataToSend))
 end;

end;

//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;  stdcall;
var iWriteOffset, iSize : Integer; //       
    uName : WideString;
begin

//   
iWriteOffset := 0;

//  dwOutBufferSize       ,   

if (dwID = 2800) then // 
begin
 if (dwOutBufferSize = 0) then
 begin
   Result := 4 ; //   ,    
   Exit ;
 end
 else
  begin
	fWriteInteger(bOutBuffer, iWriteOffset, 2); //    
	Result := 4;//    
        Exit ;
  end;
end ;

if (dwID = 2810) then //  (  )
begin
    uName := 'Repeater (test plugin) (Lazarus)';// 
    iSize := Length(uName) * 2 + 4;

     if (dwOutBufferSize = 0) then
	Result := iSize //   ,    
     else
	begin
	  fWriteText(bOutBuffer, iWriteOffset, uName);
	  Result := iSize;//    
	end;
    Exit ;
end ;

  Result := 0;//  -   
end;

//---------------------------------------------------------------------------
function PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD):  Integer;  stdcall;
var
     uRet, uCheck : WideString;
begin
// 
//     ,      ,    

//!    40000 .       .

 if (dwID = 0) then//     
 begin
    uCheck := '    ' ;
	// s := WideCharToString( wText );

// Delphi 2009        
// ( StrComp(wText, PWideChar(uCheck)) = 0)
// ( StrComp(PAnsiChar(wText), PAnsiChar(uCheck)) = 0) 
// CompareStr   CompareText
// WideSameStr(wText, uCheck) 
// ( StrComp(PCHAR(wText), PCHAR(uCheck)) = 0) 

    if  ( StrComp(PCHAR(wText), PCHAR(uCheck)) = 0) then
    begin
      uRet := '    : ';
      CopyMemory(wText, @uRet[1], Length(uRet) * 2);
      dwTextLength := Length(uRet);//  
      Result := 1;//TRUE     
      Exit ;
    end
 end ;

 Result := 0;//  FALSE       
end;

//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
//      ""   
//       "",    

    ShowMessage('Options dialog');
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
//      " "   
//       "",    

//	ShowMessage('Test plugin for CommFort 5.'
//	 + #13#10 + 'Created for CommFort software Ltd.'
//	 + #13#10 + 'Lazarus (Delphi), by ...'
//	);
    MessageDlg('Test plugin for CommFort 5.'
	 + #13#10 + 'Created for CommFort software Ltd.'
	 + #13#10 + 'Lazarus (Delphi), by ...', mtInformation, [mbOk], 0);
end;


end.

